@echo off
setlocal
set EXITCODE=0

rem for Tech Support

netstat -b -p UDP 2>&1 | findstr "ǗғKv"
if not errorlevel 1 goto finish

set YYYYMMDD=%DATE:/=%
set TIME_TEMP=%TIME: =0%
set HHNNSS=%TIME_TEMP:~0,2%%TIME_TEMP:~3,2%%TIME_TEMP:~6,2%
set TECH_SUPPORT_DIR=%~dp0tech_support_%YYYYMMDD%%HHNNSS%
mkdir "%TECH_SUPPORT_DIR%"

rem ---------------------------------------------------------------------------

set OS_INFO=%TECH_SUPPORT_DIR%\OS
mkdir "%OS_INFO%"

pushd "%OS_INFO%"

echo (9) ipconfig
ipconfig /all > ipconfig.txt
echo (10) DirectX
dxdiag /t dxdiag.txt
echo (11) msinfo32
msinfo32 /report "%OS_INFO%\msinfo32.txt"
echo (12) systeminfo
systeminfo /fo LIST > systeminfo.txt
echo (13) event log (application)
Wevtutil epl Application Application.evtx
echo (14) event log (security)
Wevtutil epl Security Security.evtx
echo (15) event log (setup)
Wevtutil epl Setup Setup.evtx
echo (16) event log (system)
Wevtutil epl System System.evtx
echo (17) netstat
netstat -abn > netstat.txt
echo (18) firewall
netsh advfirewall show currentprofile > profile_current.txt
netsh advfirewall show domainprofile > profile_domain.txt
netsh advfirewall show privateprofile > profile_private.txt
netsh advfirewall show publicprofile > profile_public.txt
netsh advfirewall firewall show rule name=all dir=in > firewall_in.txt
netsh advfirewall firewall show rule name=all dir=out > firewall_out.txt

popd


FOR /F "TOKENS=1,2,*" %%A IN ('REG QUERY "HKEY_LOCAL_MACHINE\SOFTWARE\WOW6432Node\AlliedTelesis\AT-Vista Manager EX" /v "Target"') DO IF "%%A"=="Target" SET INSTALL_EX_DIR=%%C

pushd "%INSTALL_EX_DIR%"
IF "%INSTALL_EX_DIR%"=="" goto finish

set VISTAEX_DIR=%TECH_SUPPORT_DIR%\VistaEx
mkdir "%VISTAEX_DIR%"

echo (18) pm2
set PM2_LOG=%VISTAEX_DIR%\pm2\logs
call :copy_files "bin\pm2-windows-service\.pm2\logs\*.log" "%PM2_LOG%\"
call :copy_files "web\node_modules\pm2-windows-service\src\daemon\*.log" "%PM2_LOG%\"
echo (19) mongodb\data\log
call :xcopy_files mongodb\data\log "%VISTAEX_DIR%\mongodb\data\log\"

popd
goto finish


rem ---------------------------------------------------------------------------

:xcopy_files
xcopy /e /y %1 %2
exit /b

:copy_files
if not exist %2\NUL (
  md %2
)
copy /y %1 %2
exit /b

rem ---------------------------------------------------------------------------
:finish
exit /b %EXITCODE%
